// Creative Commons Attribution-Share Alike 3.0 Unported Licence
// http://creativecommons.org/licenses/by-sa/3.0/

var CGD = window.CGD || {};

// Global Object Definitions ;^)
CGD.god = window;

// being a function that returns a clock allows us to work towards
//  instanceability; however it is still based on static HTML with ID's, 
//  so instancing is not yet practical.
CGD.DisClock = function(USER) {
var CONFIG = {
  size: 172,
  USER: {
    //birthday: new Date(1975, 12 - 1, 15, 5, 45),
    //hold: new Date(1975, 12 - 1, 15, 5, 45),
    //hold: new Date(2038, 1 - 1, 20), // a little after UNIX epoch
    //hold: new Date(2008, 6 - 1, 20, 23, 59), // summar solstice for testing daylight
    //runFrom: new Date(Date.UTC(2008, 3 - 1, 9, 7, 59, 50)), // seconds before DCT begins
    //runFrom: new Date(Date.UTC(2008, 11 - 1, 2, 6, 59, 50)), // seconds before DCT ends
    timeMultiplier: 1,
    //skip: 'day',
    //d_latitude: 42, // d_ is for degrees
    //d_longitude: -88,
    //bedtime: {wake: 'twilight', hour: 0, sleep: 8},
    //bedtime: {wake: 'dawn', hour: 0, sleep: 8},
    //bedtime: {wake: 'alarm', hour: 6, sleep: 8},
    normal: 'Disk Clock',
    //normal: 'Tzolk\'in',
    //normal: 'Debug',
    hover: 'Calendar',
    //hover: 'Debug',
    hoverMode: 'replace',
    autoShow: true,
    autoShowInhibit: 0, // hours
    autoShowDelay: 2.5, // seconds
    startupDelay: 2.5
  },
  last: null
};

// load the most useful library routines into our namespace
eval(CGD.JS.explode('CGD'));
eval(CGD.JS.explode('CGD.JS'));
eval(CGD.JS.explode('CGD.OBJECT'));
eval(CGD.JS.explode('CGD.ARRAY'));

function D(str) {
  DEBUG.p(str);
};
//DEBUG.addFilter('timestamp');

// app(lication) is the object we will return when we are done.
var app = {};
function publish(s) {
  app[s] = eval(s);
}

// provide defaults, if any
mixSafe(USER, CONFIG.USER);

if (USER.timeMultiplier != 1 && !USER.runFrom) {
  D('Subing runFrom');
  USER.runFrom = new Date();
}

// Current date object; used both for ms_now and pacha
//   Pacha used to take the milliseconds version, but it needs the timezone info.
function dt_now() {
  if (USER.hold) {
    return USER.hold;
  } else if (USER.runFrom) {
    return new Date(USER.runFrom.getTime() + DEBUG.FILTER.timestamp.dt()*USER.timeMultiplier);
  } else {
    return new Date();
  }
}

// Everything in DC calculates from this.
function ms_now() {
  var my = dt_now();
  return my.getTime() + (-my.getTimezoneOffset() * 60 * 1000);
}

// pacha is a time-place; see comments in astro.js
//   It will perform all the astronomical calcuations for it's time & place
var pacha = ASTRO.pacha(USER.d_latitude, USER.d_longitude, {dt_now: dt_now});

//this is for debugging use
function skipTime(deltaMS) {
  USER.hold = USER.hold || new Date();
  USER.hold.setTime(USER.hold.getTime() + deltaMS*USER.timeMultiplier);
  tick();
}

// disks form a logical collection; my editor also supports collapsing functions
var DISKS = function() {
  // this was a 'with' but the latest WebKit (OS X 10.5.2, Safari 3.1.1)
  //  comes up with MS_S not found in animate()
  eval(explode('CGD.TIME.UNIT'));
  
  function publish(symbol) {
    publish.symbols[symbol] = eval(symbol);
  }
  publish.symbols = {};
  
  function relativeAngleFromRevolutions(un_rev, turns) {
    return (turns == ARC.COUNTERCLOCKWISE ? (1.0 - un_rev%1) : un_rev%1) * RADIANS;
  }

  // A revolution is 0-1 rotation; abreviated 'revs' in most most places.
  //  Obvious?  The term used to be the more obtuse 'partial'
  //  un_ un-normalized i.e. 249723894.3894, possibly negative
  //  n_ normalized i.e. 0.3894
  function normalizeRevolutions(un) {
    return un < 0 ? (un%1)+1 : un%1;
  }

  // Prototype disk; the rest inherit from this with object()
  //   Think of it as a class if you like.
  var master = {
    // Data set at startup and pretty much left alone.
    name: 'disk',
    // calcUnit: Some calculations need to be adjusted before preceding.
    //   Most often this is ms/day for the longer term disks.
    calcUnit: 1,
    unit: 1, // The natural unit for the disk, in calcUnits; minutes for an hour
    count: 1, // number of units in the disk.
    
    // Following refer to marks on the disk.
    //   Usually a ratio of 4 or 5 to 1
    //   Weights are automatically determined by number of marks,
    //   but sometimes we have to tweak it to make them visually different.
    minor: 1,
    minorWeight: 1.0,
    median: 1,
    medianWeight: 1.0,
    major: 1,
    majorWeight: 1.0,
    subDivide: 1, // sometimes we want markers more often than one unit
    
    offset: 0, // in 'units'
    root: 0, // in milliseconds
    
    // graphical adjustments
    radius: 0.485,
    border: 0.03,
    //src: CONFIG.image.src,

    // Volatile data that changes during run time;
    //   This is the stuff you want to make sure and re-initialize
    //   if you use prototypal inheritance below master.
    enabled: false,
    scale: 0,
    un_position: 0, // current visual revs
    n_position: 0, // essentially cached normalized value of un_position
    
    // Methods.  May be overriden as needed in instances.
    
    clone: function(name) {
      // Method that implements protypal inheritance,
      //   making sure the volatile fields are redefined.
      var o = object(this);
      o.name = name;
      // make sure it has an independant existance.
      o.enabled = false;
      o.scale = 0;
      o.n_position = o.un_position = 0;
      return o;
    },
    // following are various string descriptions.
    toString: function() {
      return '[' + this.name + ' Disk ' + [this.describe()].join(', ') + ']';
    },
    describe: function(n_revs) {
      n_revs = n_revs || this.n_position;
      return (n_revs * this.count).toFixed(2) + " " + this.unitName + 's';
    },
    describeMajor: function(n_revs) {
      if (!this['majorNames']) {
        return null;
      } else {
        n_revs = n_revs || this.n_position;
        if (this.majorNames.length < this.count) {
          throw new RangeError([this.majorNames.length, this.count].join());
        }
        return this.majorNames[Math.floor(n_revs*this.count)];
      }
    },
    postDescription: function(un_revs) {
      // this inserts the string data into the DOM
      var adjective = un_revs < 0 ? 'remaining' : 'past';
      var description = this.describe(normalizeRevolutions(un_revs)) + ' ' + adjective;
      var major = this.describeMajor(un_revs < 0 ? this.n_position : normalizeRevolutions(un_revs));
      if (major) {
        postInfo({h2: this.name, p: [description, {b: major}]});
      } else {
        postInfo({h2: this.name, p: description});
      }
    },
    polarCollide: function(polar) {
      // the conditional here is an attempt to reduce flicker,
      //  by making the disk a hair bigger while it's selected.
      return polar.r < this.scale * (this === highlight.disk ? 0.525 : 0.5);
    },
    enable: function (as) {
      this.enabled = as;
    },
    active: function () {
      // Should it be drawn?  Scale should eventually reach zero when disabled.
      return this.enabled || this.scale > 0;
    },
    unscale: function() {
      // It's convenient to draw the overlay highlights from disk methods,
      //  but we have to counteract the disk's scaling.
      return this.scale <= 0 ? CONFIG.size : Math.sqrt(1/this.scale);
    },
    un_revs: function (ms) {
      // Target revolutions; the disk is drawn at .position, which is animated
      //   twoards this value.
      //D(ms);
      var root = ((ms / this.calcUnit) - this.root);
      var unit = ((root / this.unit) + this.offset);
      return (unit / this.count);
    },
    drawCircle: function(context, color) {
      // drawWedges is used for the back of the disk, most of the time.
      context.save();
      context.beginPath();
      context.arc(0, 0, this.radius, 0, RADIANS, ARC.CLOCKWISE);
      context.fillStyle = color || 'white';
      context.fill();
      context.restore();
    },
    drawRing: function(context, options) {
      // Also draws partial rings; see start/stop/turns
      // options {
      //   turns: ARC.CLOCKWISE,
      //   start: 0 revolutions,
      //   stop: 1 revolutions,
      //   color: 'black',
      //   scaleCorrection: false // draw unscaled if true
      //}
      options = options || {};
      var turns = options.turns || ARC.CLOCKWISE;
      context.save();
      context.rotate(RADIANS / -4);
      context.beginPath();
      context.arc(0, 0, this.radius, 
        relativeAngleFromRevolutions(options.start || 0, turns), 
        relativeAngleFromRevolutions(options.stop || 0.9999, turns), 
        turns);
      context.lineWidth = this.border;
      if (options.scaleCorrection) {
        context.lineWidth *= this.unscale();
      }
      context.strokeStyle = options.color || 'black';
      context.stroke();
      context.restore();
    },
    drawImage: function(context) {
      if (!this.image) {
        DEBUG.die("Though shalt not worship false images");
      }
      if (this.image && objectData(this.image).loaded && this.image.complete) {
        // fix for a Dashboard bug.
        if (!('imageDirection' in this)) {
          this.imageDirection = (god['widget'] && this.image.src.substr(-3, 3) == 'pdf') ? -1 : 1;
        }
        context.drawImage (this.image, -0.5, -0.5 * this.imageDirection, 1, 1);
      } else {
        this.drawImageFallback(context);
      }
    },
    drawImageFallback: function(context) {
      // Yes, it's trivial; this is an override point
      this.drawCircle(context);
    },
    drawWedges: function(context, options) {
      // Default evenly spaced colors
      //options {
      //   colors: this.colors,
      //   alpha: 1.0
      //}
      options = options || {};
      var colors = options.colors || this.colors;
      if (!colors) {
        return;
      }
      var stride = RADIANS / colors.length;
      var radius = this.radius;
      var color;
      context.save();
      context.globalAlpha = options.alpha || 1.0;
      context.rotate(RADIANS / -4);
      forEach(colors, function (xx, d) {
        // most of the time we use this routine to draw the solid back of 
        //   the disk, but sometimes it's used for a translucent overlay.
        color = colors[d] || (context.globalAlpha < 1.0 ? null : 'white');
        if (color) {
          context.beginPath();
          context.moveTo(0, 0);
          context.arc(0, 0, radius, 
            stride * d, stride * (1 + Number(d)), ARC.CLOCKWISE);
          context.closePath();
          context.fillStyle = color;
          context.fill();
        }
      });
      context.restore();
    },
    drawVariableWedges: function(context, colors, options) {
      // Colors here is really "colors and positions"
      // Usual pattern is [0, 'red', 2, 'blue', 4, 'green', RADIANS]
      // options: {
      //   radius: 1, // 0-1
      //   alpha: 1
      //}
      if (!colors) {
        return;
      }
      options = options || {};
      var radius = (options.radius || 1) * this.radius;
      var from;
      var to;
      context.save();
      context.rotate(RADIANS / -4);
      context.globalAlpha = options.alpha || 1.0;
      forEach(colors, function (it) {
        if (typeof(it) == 'string') {
          context.fillStyle = it;
        } else {
          from = to;
          to = it;
          if (from !== undefined) {
            context.beginPath();
            context.moveTo(0, 0);
            context.arc(0, 0, radius, from, to, ARC.CLOCKWISE);
            context.closePath();
            context.fill();
          }
        }
      });
      context.restore();
    },
    drawMarkers: function(context, options) {
      // This gets a little hairy because we are counterscaling the makers
      //   just a bit to help keep them visible as the disks scale down.
      //   Marks are also removed when things get to small for them to be legible.
      // options: {
      //   color: 'black',
      //   colorFunc: null // function(this, r_angle) returning color,
      //}
//      D(this.major);
//      D(this.median);
//      D(this.minor);
//      D(this.subDivide);
//      D(this.count);
      options = options || {};
      var count = this.count * this.subDivide;
      var stride = RADIANS / count;
      var my = this;
      // CONFIG.size: we want actual pixel size to make a visiblity determination.
      var perimeter = my.scale * CONFIG.size * Math.PI;
      function markerScale(divisor) {
        var interMarkPercent = divisor / count;
        var interMarkDistance = interMarkPercent * perimeter;
        var factor = Math.sqrt(interMarkPercent / my.scale);
        return (interMarkDistance < 5) ? 0 : factor;
      }
      var majorWeight = markerScale(this.major) * this.majorWeight;
      var medianWeight = markerScale(this.median) * this.medianWeight;
      var minorWeight = markerScale(this.minor) * this.minorWeight;
      var weight;
      var radius;
      var angle;
      var width;
      context.save();
      context.strokeStyle = options.color || 'black';
      context.rotate(RADIANS / -4);

      for (var i = 0;i < count; i++) {
        if (i == 0) {
          weight = 1;
        } else if (i % this.major == 0) {
          weight = majorWeight;
        } else if (i % this.median == 0) {
          weight = medianWeight;
        } else if (i % this.minor == 0){
          weight = minorWeight;
        } else {
          weight = 0;
        }
        if (weight > 0.0001) {
          // The marks are actually small slices of a ring
          //   This gives a nice narrowing effect near center,
          //   but I haven't tested the performance relative to straight lines.
          
          // lineWidth here is actually the 'length' of the mark
          context.lineWidth = 0.3 * weight;
          // and radius is the center of the mark.
          radius = this.radius - this.border/2 - context.lineWidth/2;
          if (radius < 0) {
            continue;
          }
          angle = stride * i;
          // width is the 'real' line width, or thickness
          width = RADIANS * 0.015 * weight;
          if (options.colorFunc) {
            context.strokeStyle = options.colorFunc.call(this, angle);            
          }  // no else because it never changes otherwise
          context.beginPath();
          context.arc(0, 0, radius, angle - width, angle + width, ARC.CLOCKWISE);
          context.stroke();
        }
      }
      context.restore();
    },
    render: function(context) {
      // Core drawing function; main override point for custom rendering
      //   Mostly just called by .draw
      if (this.image) {
        this.drawImage(context);
        // drawWedges only does something if colors is defined.
        this.drawWedges(context, {alpha: 0.5});
      } else {
        this.drawWedges(context);
        this.drawRing(context);
        this.drawMarkers(context);
      }
    },
    draw: function(context) {
      //besides being more efficient, firefox will stop talking to us if we
      // ever try to do scale 0
      if (this.scale > 0) {
        context.save();
        context.rotate(
          relativeAngleFromRevolutions(this.n_position, ARC.COUNTERCLOCKWISE));
        context.scale(this.scale, this.scale);
        this.render(context);
        context.restore();
      }
    },
    drawOverlay: function(context, n_revs, kind) {
      // The mouse-hover selection arcs.
      var color;
      var turns;
      var stop;
      switch(kind) {
        case 'future':
          stop = -this.n_position;
          color = 'red';
          turns = ARC.COUNTERCLOCKWISE;
          break;
        case 'past':
          stop = this.n_position;
          color = 'blue';
          turns = ARC.CLOCKWISE;
          break;
        default:
          stop = normalizeRevolutions((1 - n_revs) + this.n_position);
          color = 'yellow';
          turns = ARC.CLOCKWISE;
          break;
      }
      //besides being more efficient, firefox will stop talking to us if we
      // ever try to do scale 0
      if (this.scale > 0) {
        context.save();
        context.scale(this.scale, this.scale);
        context.rotate(
          relativeAngleFromRevolutions(this.n_position, ARC.COUNTERCLOCKWISE));
          
        // The line to the target point
        this.drawRing(context, {
          color: color,
          scaleCorrection: true,
          start: 0,
          stop: normalizeRevolutions(stop),
          turns: turns
        });
        
        // The dot at the root point.
        context.beginPath();
        context.arc(0, -(this.radius), this.border*2*this.unscale(),
          0, RADIANS, ARC.CLOCKWISE);
        context.fillStyle = color;
        context.fill();
        
        context.restore();
      }
      this.postDescription(stop);
    },
    animate: function(property, to) {
      // Animation is defined to operate without dedicated state.
      //   The advantage is that it responds smoothly to mousein/mouseout etc.
      //   The disadvantage is that we end up having to pop at the end
      //     because there isn't enough delta to drive useful movement.
      // Returns true when animation has stopped.
      var delta = to - this[property];
      delta = Math.min(delta, 1);
      delta = Math.max(delta, -1);
      //D([this.name, delta]);
      if (-0.01 < delta && delta < 0.01) {
        this[property] = to;
        return true;
      } else {
        this[property] += Math.sin(delta * RADIANS / 4) * DISKS.animating();
        return false;
      }
    },
    update: function(ms, scale) {
      if (this.active()) {
        this.animate('scale', this.enabled ? scale : 0);
        this.updatePosition(ms);
      }
      // no caching of active: animation of scale may have changed the answer
      return this.active();
    },
    updatePosition: function(ms) {
      var un_to = this.un_revs(ms);
      var delta = un_to - this.un_position;
      // You might think that we wouldn't need to abs(delta)
      //   And you'd be right if you don't live an a daylight crazy time area.
      var magnitude = Math.abs(delta);
      // this is in calcUnits of revolution
      var small = 1 / (this.count * this.unit);
      
      if (this.delay() < 1) {
        // superfast time
        this.un_position = Math.floor(un_to);
        this.animatingLastTime = false;
      } else if (this.delay() < 1000 || magnitude < small) {
        // 1000: animation won't be able to keep up with fast disks
        //  Other check is for small, normal, updates
        this.un_position = un_to;
        this.animatingLastTime = false;
      } else {
        // cap animation at two revolutions
        if (magnitude > 3) {
          //D([this.name, delta]);
          var skip = (this.un_position == 0 ? 1 : 2);
          var offset = (delta < 0 ? -skip : skip);
          if (offset != 0) {
            this.un_position = Math.floor(un_to) - offset + this.n_position;
          }
        }
        this.animate('un_position', un_to);
        if (!this.animatingLastTime) {
          this.jump();
        }
        this.animatingLastTime = true;
      }
      // most other things need normalized revolutions, so pre-calculate it.
      this.n_position = normalizeRevolutions(this.un_position);
    },
    // hook for extension
    jump: function () {},
    // How often does this disk need to be updated to move smoothly?
    delay: function () {return this.calcUnit / Math.abs(USER.timeMultiplier || 1);},
    loadImage: function() {
      // Call this ASAP to get the images loading.
      //   Even then images may not available on the first draw
      //   See logo disk's override using an existing DOM element.
      if (this.src) {
        //D(this.src);
        this.image = new Image(CONFIG.size, CONFIG.size);
        loadFlag(this.image, this.src);
      }
    },
    cacheColors: function () {
      if (this.color && !this.colors) {
        // null is translated to white for calculating the gradient;
        //   null is special in that it won't be drawn when translucent
        this.colors = CGD.RGB.interpolate(this.color, null,
          (this.major == this.count) ? 4 : (this.count*this.subDivide/this.major));
      }
    },
    cache: function () {
      this.cacheColors();
      // Doesn't call loadImage, because the timing is off;
      //   We need to get loadImage going ASAP to have the images ready in time.
    },
    lastEntry: null
  };
  publish('master');

  // Basically the disk class constructor.
  //   'args' is an object of custom properties.
  function create(name, calcUnit, unit, count, args) {
    var my = object(master);
    my.name = name;
    my.calcUnit = calcUnit;
    my.unit = unit;
    my.count = count;
    
    // Estimate marking positions that work in most cases.
    //   The args overrides will fix the ones that don't work.
    if (count % 4 == 0) {
      my.major = Math.floor(count / 4);
    } else if (count % 5 == 0) {
      my.major = 5;
    } else {
      my.major = count;
    }
    if (count < 10) {
      my.subDivide = 4;
      my.major = 4;
      my.median = 1;
    } else if (count % 12 == 0) {
      my.median = Math.floor(count / 12);
    } else if (count % 5 == 0) {
      my.median = 5;
    } else {
      my.median = count;
    }
    
    mix(my, args);
    my.unitName = my.unitName || TIME.UNIT.nameFor(my.calcUnit * my.unit);
    
    if (my['majorNames'] && my.majorNames.length < my.count) {
      throw new RangeError([my.majorNames.length, my.count].join());
    }
    
    // If we wait until cache, the image isn't available on first draw.
    my.loadImage();
    
    return my;
  }
  
  // Mayan long count disks
  var pictun = create('Pictun', MS_D, D_U * U_T * T_KAT * KAT_BAKT, BAKT_PICT, {
    color: 'blue'
  });
  var baktun13 = create('13 Baktun', MS_D, D_U * U_T * T_KAT * KAT_BAKT, 13, {
    color: 'purple'
  });
  var baktun = create('Baktun', MS_D, D_U * U_T * T_KAT, KAT_BAKT, {
    color: 'red'
  });
  var katun = create('Katun', MS_D, D_U * U_T, T_KAT, {
    color: 'pink'
  });
  var tun = create('Tun', MS_D, D_U, U_T, {
    major: 6,
    color: 'yellow'
  });
  var uinal = create('Uinal', MS_D, 1, D_U, {
    unitName: 'kin',
    color: 'green'
  });

  // laziness
  forEach([pictun, baktun13, baktun, katun, tun, uinal], function(d) {
    d.root = -MAYAN_EPOCH;
  });

  // Mayan Tzolk'in
  var tzolkinDays = create('Tzolk\'in Days', MS_D, 1, D_TM, {
    majorNames: [
      "Imix'",
      "Ik'",
      "Ak'b'al",
      "K'an",
      "Chikchan",
      "Kimi",
      "Manik'",
      "Lamat",
      "Muluk",
      "Ok",
      "Chuwen",
      "Eb'",
      "B'en",
      "Ix",
      "Men",
      "Kib'",
      "Kab'an",
      "Etz'nab'",
      "Kwaak",
      "Ajaw"
    ],
    color: 'red'
  });

  var trecena = create('Tzolk\'in Trecena', MS_D, 1, D_TR, {
    color: 'yellow'
  });

  // Xth time I've swapped the colors.  Lets' try to reconstruct the current
  //  reasoning.  The large cycle (days, 20) should appear fewer times around
  //  the year (13).  Vice Versa.  On the year disk, there should be
  //  13 parts in the red cycle, and 20 in the yellow
  var tzolkinYear = create('Tzolk\'in Year', MS_D, 1, D_TM * D_TR, {
    dayColors: extendRepeat([tzolkinDays.color, null], D_TR),
    trecenaColors: extendRepeat([trecena.color, null], D_TM),
    render: function(context) {
      // Could theoretically combine first two operations, but it would be
      //  less obvious, and would actually cause more draw operations to be issued.
      this.drawCircle(context);
      this.drawWedges(context, {colors: this.dayColors, alpha: 0.5});
      this.drawWedges(context, {colors: this.trecenaColors, alpha: 0.5});
      this.drawRing(context);
      this.drawMarkers(context);
    },
    describeMajor: function(n_revs) {
      var day = tzolkinDays.describeMajor((n_revs * D_TR) % 1);
      var tre =    1 + Math.floor(D_TR * ((n_revs * D_TM) % 1));
      return tre.toString() + " " + day;
    },
    major: D_TM * D_TR,
    median: D_TM,
    minor: D_TR
  });

  // more laziness; also had to muck with it a lot in the beginning
  forEach([tzolkinYear, tzolkinDays, trecena], function(d) {
    d.root = -4 - 16*D_TM;
    d.unitName = 'kin';
  });

  var century = create('Century', MS_D, D_SY, Y_C, {
    color: '#F0F',
    root: -70 * D_SY,
    major: 10,
    median: 5,
    medianWeight: 0.7
  });

  var unix = create('Unix', MS_S, S_M * M_H * H_D * D_SY, Math.pow(2,31) / (S_M * M_H * H_D * D_SY), {
    color: 'gray',
    major: 16,
    median: 4,
    //root: -Math.pow(2, 31),
    // this isn't quite right - I'm overflowing to 0 instead of negative.
    describeMajor: function(n_revs) {
      return Math.floor((ms_now()/MS_S) % Math.pow(2, 31)).toString(16);
    }
  });
  unix.subDivide = 64/unix.count;

  var decade = create('Decade', MS_D, D_SY, 10, {
    root: -70 * D_SY,
    color: '#08F'
  });

  var lifetime = create('Lifetime', MS_D, D_SY, Y_G * G_L, {
    color: '#80F'
  });

  var generation = create('Generation', MS_D, D_SY, Y_G, {
    color: 'blue'
  });

  var birthday = create('Birthday', MS_D, 1, D_SY, {
    color: 'pink'
  });

  if (USER.birthday) {
    forEach([lifetime, generation, birthday], function(d) {
      d.root = USER.birthday.getTime() / MS_D;
    });
  }

  // Tropical zodiac is aligned to the seasons; there is also
  //   Sidreal zodiac, which is aligned to the stars, and 
  //   13 Astronomical zodiacs, which don't have even divisions.
  var tropicalZodiac = create('Tropical Zodiac', MS_D, D_SY/12, 12, {
    colors: [
      'red',
      'pink',
      'yellow',
      'grey',
      'orange',
      'navy',
      '#FF8',
      '#800',
      'purple',
      '#220',
      'turquoise',
      '#2e8b57'
    ],
    majorNames: [
      'Aires',
      'Taurus',
      'Gemini',
      'Cancer',
      'Leo',
      'Virgo',
      'Libra',
      'Scorpio',
      'Sagittarius',
      'Capricorn',
      'Aquarius',
      'Pices'
    ],
    root: new Date(1970, 3 - 1, 21).getTime() / MS_D,
    subDivide: 3,
    major: 3*3,
    median: 1*3,
    lastEntry: null    
  });

  var year = create('Solar Year', MS_D, D_SY/12, 12, {
    colors: ['blue', 'green', 'orange', 'brown'],
    majorNames: [
      '~January',
      '~February',
      '~March',
      '~April',
      '~May',
      '~June',
      '~July',
      '~August',
      '~September',
      '~October',
      '~November',
      '~December'
    ],
    subDivide: 4,
    major: 3*4,
    median: 1*4,
    render: function(context) {
      context.save();
      context.rotate(RADIANS * -9 / 365);
      this.drawWedges(context);
      this.drawRing(context);
      // night time shadow to show daylight variance
      context.fillStyle = "black";
      context.globalAlpha = 0.5;
      context.beginPath();
      context.arc(0, -0.01, 0.44, 0, RADIANS, ARC.CLOCKWISE);
      context.fill();
      context.restore();
    
      this.drawMarkers(context);
    },
    lastEntry: null    
  });

  // The real moon phase can vary by more than half a day;
  //   This disk is only an approximation.
  var moon = create('Moon', MS_D, 1, D_LM, {
    // lunar epoch: 
    // http://en.wikipedia.org/wiki/Full_moon_cycle 2008-03-09
    //root: Date.UTC(1890, 1 - 1, 20, 23, 49) / MS_D, // dashboard bug... *sigh*
    root: Date.UTC(1992, 8 - 1, 28) / MS_D,
    // Moon image from the Fourimlab moon viewer:
    //   http://www.fourmilab.ch/cgi-bin/Earth/action?opt=-s&img=MoonTopo.evif
    src: 'images/Moon.png',
    describePhase: function(n_revs, quarter) {
      if (n_revs < 0.03) {
        return "New";
      } else if (n_revs < 0.22) {
        return "Crescent"; 
      } else if (n_revs < 0.28) {
        return quarter + " Quarter";
      } else if (n_revs < 0.47) {
        return "Gibbeous";
      } else {
        return "Full";
      }
    },
    describeMajor: function(n_revs) {
      if (n_revs < 0.5) {
        return "Waxing " + this.describePhase(n_revs, "First");
      } else {
        return "Waning " + this.describePhase(1 - n_revs, "Third");
      }
    }
  });

  var week = create('Week', MS_S * S_M * M_H, H_D, D_W, {
    // Colors assembled from various sources in partial agreement, including:
    //   http://www.usmta.com/Thai-Birthday.htm
    //   http://en.wikipedia.org/wiki/Color_of_the_day
    //   http://www.thai-blogs.com/index.php?blog=5&title=what_is_your_lucky_colour&more=1&c=1&tb=1&pb=1
    // There is also a modern system, which differs substantially from the one used:
    //   http://www.typotheque.com/site/tshirt.php?id=1
    colors: ['red', 'yellow', 'pink', 'green', 'orange', 'blue', 'purple'],
    majorNames: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
    offset: 4,
    subDivide: 6,
    major: 6,
    median: 3
  });

  var day = create('Day', MS_S * S_M, M_H, H_D, {
    major: 12,
    median: 4,
    minorWeight: 0.8,
    cache: function() {
      var my = this;
      function revs(hours) {
        return hours / 24;
      }
      function angle(hours) {
        return relativeAngleFromRevolutions(revs(hours), ARC.CLOCKWISE);
      }
      function calculate() {
        //D('calculate'); // fires twice, but does it really matter?
      
        // Remember pacha (time-place) from way in the beginning?
        //   This is really the only place it's used.
        var noon = pacha.m_solarNoon() / 60;
        var daylight = Math.max(pacha.m_hourAngle(90.833) / 60, 0.001);
        var twilight = Math.max(pacha.m_hourAngle(99) / 60, 0.001);
        // Basic daylight/twilight
        my.nightBegin = angle(noon + twilight);
        my.nightEnd = angle(noon - twilight);
        my.sunset = angle(noon + daylight);
        my.sunrise = angle(noon - daylight);
      
        // Bed time gets a little more complex because of the parameterization.
        var outbed = 0;
        var inbed = 0;
        if (USER['bedtime'] &&
           typeof(USER.bedtime['wake']) == 'string' &&
           typeof(USER.bedtime['hour']) == 'number' &&
           typeof(USER.bedtime['sleep']) == 'number') {
          //D(USER.bedtime);
          switch (USER.bedtime.wake) {
            default:
            case 'twilight': outbed = noon - twilight; break;
            case 'dawn': outbed = noon - daylight; break;
            case 'alarm': outbed = 0; break;
          }
          outbed += USER.bedtime.hour;
          inbed = outbed - USER.bedtime.sleep;
        }
        my.inBed = angle(inbed);
        my.outBed = angle(outbed);
      
        // and save intermediary values in case we need them later
        my.noon = angle(noon);
        my.daylight = revs(daylight) * RADIANS;
        my.twilight = revs(twilight) * RADIANS;
      
        // recalculate the values once a day
        my.cache.timeout = setTimeout(calculate, my.delay() * my.unit * my.count);
      }
      if (!my.cache.timeout) {
        calculate();
      }
    },
    jump: function() {
      clearTimeout(this.cache.timeout);
      this.cache.timeout = null;
      this.cache();
    },
    render: function(context) {
      // Solar noon marker
      var width = (RADIANS / 180); // i.e., two degrees (each side, total four)
    
      var sky = '#3BB9FF';
      // [position, color, (position, color,...) position]
      this.drawVariableWedges(context, [
        this.sunrise, sky,
        this.noon - width, 'red',
        this.noon + width, sky,
        this.sunset, '#00F',
        this.nightBegin, '#424',
        this.nightEnd, '#00F',
        this.sunrise
      ]);
    
      // bed time can't be an ordinary wedge because it blows up at the
      //  summer solstice with less than 8 hours darkness
      //  And because it's now customizable.
      if (this.inBed != this.outBed) {
        this.drawVariableWedges(context, [
          this.inBed, '#000', this.outBed], {alpha: 0.5});
      }
    
    
      // custom color the markers to show up better
      var darkness = '#BBB';
      var twilight = 'yellow';
      var daylight = 'white';
      this.drawMarkers(context, {colorFunc: function(angle) {
        angle %= RADIANS;
        if (angle < this.nightEnd) {
          return darkness;
        } else if (angle < this.sunrise) {
          return twilight;
        } else if (angle < this.sunset) {
          return daylight;
        } else if (angle < this.nightBegin) {
          return twilight;
        } else {
          return darkness;
        }
      }});
    
      // Solar noon marker - translucent overlay so visible on markers
      //   A simple marker color won't do, because the solar marker
      //    can be smaller than regular markers
      this.drawVariableWedges(context,
        [this.noon - width, 'red', this.noon + width],
        {alpha: 1 - (0.6 * this.scale)});

      this.drawRing(context);
    },
    last: null
  });

  var hour12 = create('12 Hour', MS_S * S_M, M_H, 12, {
    describeMajor: function(n_revs) {
      // Don't mind the parameters, we need a larger context than the
      //   usual revs in order to be able report AM/PM
      var progress = this.un_position % 2;
      return (progress < 1) ? 'AM' : 'PM';
    },
    subDivide: 5,
    major: 5*3,
    median: 5,
    color: 'cyan'
  });

  var hour4 = create('4 Hour', MS_S * S_M, M_H, 4, {
    subDivide: 12,
    major: 12,
    median: 3,
    color: 'green' // dark green
  });

  var hour = create('Hour', MS_S, S_M, M_H, {
    color: '#0F0' // light green
  });

  var minute15 = create('15 Minute', MS_S, S_M, 15, {
    subDivide: 4,
    major: 5*4,
    median: 4,
    color: 'yellow'
  });

  var minute5 = create('5 Minute', MS_S, S_M, 5, {
    color: 'orange'
  });

  var minute = create('Minute', MS_S, 1, S_M, {
    color: 'red'
  });

  var second5 = create('5 Second', 500, 2, 5, {
    color: '#C00'
  });

  var second = create('Second', 100, 1, 10, {
    color: '#800',
    subDivide: 10,
    major: 10
  });

  var logo = create('Logo', 100, 1, 1, {
    //src: 'Default.png',
    loadImage: function() {
      // use a DOM object, which should hopefully be loaded before we need it.
      this.image = document.getElementById('default');
      loadFlag(this.image, this.image.src);
    },
    // a white disk would be kind of ugly
    drawImageFallback: function(context) {},
    enabled: true,
    scale: 1,
    // Using scale in the revs makes it spin on the way down
    //  it will kind of stink if it ever gets used 'normally' though.
    un_revs: function(ms) {return this.scale;},
    polarCollide: function(polar) {return false;}
  });

  var nil = create('Nil', 100, 1, 1, {
    draw: function() {},
    drawOverlay: function() {this.postDescription(0);},
    postDescription: function(un_revs) {
      postInfo({p: ["ALT: target", "CTRL: normal", "SHIFT: slow"]});
    }
  });

  var all = [
    pictun,
    baktun13,
    baktun,
    century,
    lifetime,
    unix,
    decade,
    generation,
    katun,
    tropicalZodiac,
    birthday,
    year,
    tun,
    tzolkinYear,
    moon,
    uinal,
    tzolkinDays,
    trecena,
    week,
    day,
    hour12,
    hour4,
    hour,
    minute15,
    minute5,
    minute,
    second5,
    second,
    logo
  ];
  publish('all');
  
  var sets = [
    {name: "Long Count", disks: [pictun, baktun, katun, tun, uinal, day]},
    {name: "Apocolyptic", disks: [baktun13, baktun, katun, tun, uinal, day]},
    {name: "Century", disks: [century, decade, year]},
    {name: "Lifetime", disks: [lifetime, generation, tropicalZodiac, birthday]},
    {name: "Unix", disks: [unix]},
    {name: "Tzolk'in", disks: [tzolkinYear, tzolkinDays, trecena, day]},
    {name: "Calendar", disks: [year, moon, week]},
    {name: "Disk Clock", disks: [day, hour4, hour, minute15]},
    {name: "Classic Clock", disks: [hour12, hour, minute]},
    {name: "Fine", disks: [minute5, minute, second]},
    {name: "Debug", disks: [
    //    pictun,
    //    baktun13,
    //    baktun,
    //    century,
    //    lifetime,
    //    generation,
    //    katun,
    //    tun,
    //    uinal,
    //    tzolkinYear,
    //    tzolkinDays,
    //    trecena,
//          tropicalZodiac
    //    year
    //    moon,
//        week,
    //    day,
    //    hour12,
    //    hour4,
        hour
//        minute15
    //    minute5,
    //    minute
    //    second5
    //    second
//        logo
      ]}
  ];
  publish('sets');
  
  // remove sets which can't be used.
  if (!USER.birthday) {
    sets.splice(keyWhich(sets, hasName('Lifetime')), 1);
  }
  
  if (USER.normal != 'Debug' && USER.hover != 'Debug') {
    sets.splice(keyWhich(sets, hasName('Debug')), 1);
  }
  
  var animationDelay = MS_D;
  var animationStep = 0.1;
  var normalDelay = MS_S;
  
  // update and helpers.  Called before drawing to perform model updates.
  function setTicker() {
    clockTicker.configure(Math.min(
      animationDelay || MS_D,
      normalDelay || MS_S));
  }
  
  function updateDisks(ms) {
    var scale = 1.0;
    forEach(all, function(d) {
      if (d.update(ms, scale)) {
        if (d.enabled) {
          scale *= 0.8;
        }
      }
    });
  }
  
  function update(options) {
    animationDelay = MS_D;
    updateDisks(ms_now());
    setTicker();
  }
  publish('update');
  
  // draw might not be called strictly with update - initial screen setup, etc.
  function draw(context) {
    forEach(all, function(d) {
      if (d.active()) {
        d.draw(context);
      }
    });
  }
  publish('draw');

  function drawOverlay(context) {
    if (highlight.disk) {
      highlight.disk.drawOverlay(context, highlight.n_revs, highlight.mode);
    }
  }
  publish('drawOverlay');

  // shorthand for computed style property
  function prop(element, p) {
    return parseInt(document.defaultView.getComputedStyle(element, "").getPropertyValue(p), 10);
  }

  var postedHtml = "";
  function postInfo(info) {
    var div = document.getElementById('info');
    if (div) {
      var html = CGD.HTML.from(info);
      if (html != postedHtml) {
        //D(html);
        postedHtml = html;
        div.innerHTML = html;
        if ('widget' in god) {
          var target = prop(div, 'top') + prop(div, 'height');
          if (target > windowSize().h) {
            window.resizeTo(prop(div, 'width'), target);
          }
        }
      }
    }
  }
  publish('postInfo');
  
  // Various things call this to inform the system that it needs to run
  //   at animation speed.  (Otherwise there might be up to a day between
  //   updates; usually it's a second.)
  // It also returns an animation step to implement the slow-motion behavior.
  //   Notice that animationStep is only modified when this function is called
  //   with an options.slow parameter, so it will maintain it's last value.
  function animating(options) {
    options = options || {};
    animationDelay = MS_S / 24;
    if (options.slow != undefined) {
      if (options.slow) {
        animationStep = 0.01;
      } else {
        animationStep = 0.1;
      }
    }
    return animationStep;
  }
  publish('animating');
  
  function polarFromRect(x, y) {
    var a = x == 0 ? 0.25    : Math.atan(Math.abs(y/x)) / RADIANS;
    var b = x <  0 ? 0.5 - a : a;
    var p = y <  0 ? 1   - b : b;
    return {
      p: p,
      r: Math.sqrt(x*x + y*y)
    };
  }
  
  // Properties is arbitrary extra properties
  //   to add to the resulting highlight object
  function over(px, py, properties) {
    var polar = polarFromRect(
      (px / CONFIG.size) - 0.5,
      (py / CONFIG.size) - 0.5);
//    D([polar.p, polar.r]);
    for (var i = all.length - 1; i >= 0; i--) {
      if (all[i].polarCollide(polar)) {
        var it = {
          disk: all[i],
          n_revs: normalizeRevolutions(1.0 - (polar.p + 0.25))
        };
        mix(it, properties);
        return it;
      }
    }
    return {disk: nil, n_revs: 0};
  }
  publish('over');
  
  var highlight = {
    disk: null,
    n_revs: 0,
    mode: null
  };
  publish('highlight');
  
  // select the specified disk as the highlighted disk.
  function select(s) {
    s = s || {disk: null, n_revs: 0};
    s.mode = s.mode || 'current';
    if (s.disk != highlight.disk ||
        s.n_revs != highlight.n_revs ||
        s.mode != highlight.mode) {
      highlight.disk = s.disk;
      highlight.n_revs = s.n_revs;
      highlight.mode = s.mode;
      if (highlight.mode == 'current') {
        highlight.mode = highlight.n_revs > 0.5 ? 'future' : 'past';
      }
      if (!highlight.disk) {
        postInfo(null);
      }
      app.drawOverlay();
    }
  }
  publish('select');
  
  // Combine an arbitrary list of disk sets, and make only those enabled.
  //   Also calculates the necessary refresh rate for the new set.
  function configure(whichSets) {
    var minimum = decade.delay();
    forEach(all, function(d) {
      d.enable(false);
    });
    forEach(whichSets, function(name) {
      forEach(valueWhich(sets, hasName(name)).disks, function(d) {
        d.enable(true);
        minimum = Math.min(minimum, d.delay());
      });
    });
    normalDelay = Math.max(100, minimum);
    setTicker();
  }
  publish('configure');
  
  function setup() {
    forEach(all, function(d) {
      d.cache();
    });
    configure([CONTROLSTATE.normal]);
    CGD.HTML.select.populate('normal-popup', sets, CONTROLSTATE.normal);
    CGD.HTML.select.populate('hover-popup', sets, CONTROLSTATE.hover);
    CGD.HTML.radio.set('mode-' + CONTROLSTATE.hoverMode);
    CGD.HTML.check.set('auto-show', CONTROLSTATE.autoShow);
  }
  publish('setup');

  function toString() {return 'DISKS';}
  publish('toString');

  return publish.symbols;
} ();
publish('DISKS');

function draw() {
  CGD.DRAW.on('canvas', DISKS.draw, {origin: 'center'});
  if (DISKS.highlight.disk) {
    drawOverlay();
  }
}
publish('draw');

function drawOverlay() {
  CGD.DRAW.on('overlay', DISKS.drawOverlay, {origin: 'center'});
}
// Dashboard will quite happily send us mouse events every millisecond or so
drawOverlay = TIME.throttle(drawOverlay, 1000/30);
publish('drawOverlay');

var animationStartFlag = flag();

function tick() {
  if (animationStartFlag.flag) {
    DISKS.update();
  }
  draw();
}

function skipTick() {
  var a = Math.random() * Math.random();
  //D(a);
  skipTime(a * TIME.UNIT.forName(USER.skip));
}

// 1000 is an arbitrary placeholder value here
var clockTicker = CGD.TIME.ticker(tick, 1000);
var skipTicker = CGD.TIME.ticker(skipTick, 3000);

var doneButton;
var infoButton;

function setup_buttons() {
  if ('AppleGlassButton' in god) {
    doneButton = new AppleGlassButton(
      document.getElementById("done"), 
      "Done",
      flipToFront);
  }
  if ('AppleInfoButton' in god) {
    infoButton = new AppleInfoButton(
      document.getElementById("infoButton"),
      document.getElementById("front"),
      "white", "white",
      flipToBack);
  }
  
  if (!('widget' in god)) {
    var back = document.getElementById('back');
    back.style.left = 172;
    back.style.display = 'block';
    back.style.backgroundColor = '#444';
    var body = document.getElementsByTagName('body')[0];
    body.style.backgroundColor = '#444';
  }
}

function setup_events() {
  var hoverMode = false;
  var autoShow = false;
  var autoShowAt = 0;
  var effectiveMode = false;
  var shift = false;
  var alt = false;
  var control = false;
  var x = 0;
  var y = 0;
  
  // This is the bulk of the hover switching logic.
  function updateDisks() {
    var mode = (hoverMode || autoShow) && !control;
    DISKS.animating({slow: shift});
    if (mode != effectiveMode) {
      effectiveMode = mode;
      DISKS.configure(hoverModeDisplay(effectiveMode));
    }
    tick();
  }
  
  function updateKeys(e) {
    shift = e.shiftKey;
    alt = e.altKey;
    control = e.ctrlKey;
  }
  
  function mouseover(e) {
    document.getElementById('keyboard-input').focus();
    hoverMode = true;
    updateKeys(e);
    updateDisks();
  }

  function mouseout(e) {
    hoverMode = false;
    updateKeys(e);
    DISKS.select(null);
    updateDisks();
  }
  
  function mousemove(e) {
    updateKeys(e);
//    D([e.clientX, e.clientY]);
    x = e.clientX;
    y = e.clientY;
    DISKS.select(DISKS.over(x, y, alt ? {mode: 'target'} : null));
    updateDisks();
  }
  
  function keyevent(e) {
//    D(e);
    //D([e.keyCode, e.charCode]);
    //clockTicker.stop();
    //if (e.type == 'keydown') {}
    updateKeys(e);
    // Even thought the pointer hasn't moved,
    //   select/over is where the overlay mode switching happens
    DISKS.select(DISKS.over(x, y, alt ? {mode: 'target'} : null));
    updateDisks();
  }
  
  function autoshowevent() {
    if (CONTROLSTATE.autoShow && USER.autoShowDelay > 0 && 
        autoShowAt + USER.autoShowInhibit*1000*60*60 < ms_now()) {
      autoShow = true;
      updateDisks();
      setTimeout(function() {autoShow = false; updateDisks();},
        USER.autoShowDelay * 1000);
    } else {
      // safety in case the timeout gets lost
      autoShow = false;
      updateDisks();
    }
    autoShowAt = ms_now();
  }
  app.autoshowevent = autoshowevent;

  var front = document.getElementById('front');
  addEvent(front, 'mouseover', mouseover);
  addEvent(front, 'mouseout', mouseout);
  addEvent(front, 'mousemove', mousemove);

  var keyboard = document.getElementById('keyboard-input');
  addEvent(keyboard, 'keydown', keyevent);
  addEvent(keyboard, 'keyup', keyevent);

  // make links work in Dashboard
  if ('widget' in god) {
    var links = document.getElementsByTagName('a');
    forEachNode(links, function(a) {
      if (typeof(a.href) == 'string' && a.href.substr(0, 7) == 'http://') {
        a.href = "javascript:void widget.openURL('" + a.href + "')";
      }
    });
  }
}

// Decodes the hover-mode and the hover state (active) to figure out what
//   should be displayed.
function hoverModeDisplay(active) {
  var normal = [CONTROLSTATE.normal];
  var hover = [CONTROLSTATE.hover];
  var both = [CONTROLSTATE.normal, CONTROLSTATE.hover];
  return {
    add: [normal, both],
    replace: [normal, hover],
    subtract: [both, normal]
  }[CONTROLSTATE.hoverMode][active ? 1 : 0];
}

function setup_changed() {
  
  // This is sort of a macro; it returns a function that updates the target proprety
  function diskchanged(property) {
    if (!(property in CONTROLSTATE)) {
      throw RangeError(property + ' not in CONTROLSTATE');
    }
    return function (e) {
      CONTROLSTATE[property] = e.target.value;
      DISKS.animating();
      // We make a perhaps rash assumption that the mouse isn't hovering
      //   if it's modifying things.
      DISKS.configure(hoverModeDisplay(false));
    };
  }

  function autochanged(e) {
    var changed = (CONTROLSTATE.autoShow != e.target.checked);
    CONTROLSTATE.autoShow = e.target.checked;
    if (changed && CONTROLSTATE.autoShow) {
      if (USER.autoShowDelay <= 0) {
        USER.autoShowDelay = 2.5;
      }
      app.autoshowevent();
    }
  }

  // Yes, diskchanged should be a call - it returns the real handler function.
  addEvent(document.getElementById('normal-popup'), 'change', diskchanged('normal'));
  addEvent(document.getElementById('hover-popup'), 'change', diskchanged('hover'));

  forEach(['mode-add', 'mode-replace', 'mode-subtract'], function(id) {
    addEvent(document.getElementById(id), 'click', diskchanged('hoverMode'));
  });

  addEvent(document.getElementById('auto-show'), 'click', autochanged);
}

function animationStart() {
  clockTicker.start();
  if (USER.skip && TIME.UNIT.forName(USER.skip) > 0) {
    skipTicker.start();
  }
  app.autoshowevent();
  animationStartFlag();
}

function setup()
{
  //D('setup beginning');
  DEBUG.onload();
  DEBUG.on();
  loadPreferences();
  setup_buttons();
  setup_events();
  setup_changed();
  DISKS.setup();
  draw();
  drawOverlay();
  setTimeout(animationStart, USER.startupDelay * 1000);
  //D('setup ending');
  return app;
}
publish('setup');


// Onshow fires once on startup
//   technically, it's hidden at startup, but we want to use this event for 
//   'dashboard activated'
var hidden = false;
function onshow() {
  if (hidden) {
    hidden = false;
    draw();
    animationStart();
  }
}

function onhide() {
  clockTicker.stop();
  skipTicker.stop();
  hidden = true;
}

function onremove () {
  onhide();
  cleansePreferences();
}

if ('widget' in god) {
  widget.onhide = onhide;
  widget.onshow = onshow;
  widget.onremove = onremove;
}

god.onerror = god.onerror || function(e) {
  D('stopping clock');
  clockTicker.stop();
  skipTicker.stop();
};

function flipToFront() {
  savePreferences();
  flip('back', 'front');
  animationStart();
}

function flipToBack() {
  clockTicker.stop();
  skipTicker.stop();
  flip('front', 'back');
}

function flip(from, to) {
  if ('widget' in god) {
    widget.prepareForTransition("To" + STRING.capital(to));
    document.getElementById(from).style.display = 'none';
    document.getElementById(to).style.display = 'block';
    setTimeout(drawForTransition, 0);
  }
}

function drawForTransition() {
  draw();
  if ('widget' in god) {
    setTimeout(function() {widget.performTransition();}, 0);     
  }
}
publish('drawForTransition');

// defaults read widget-com.computergenerateddreams.widget.diskclock
var CONTROLSTATE = {
  normal: USER.normal,
  hover: USER.hover,
  hoverMode: USER.hoverMode,
  autoShow: USER.autoShow && USER.autoShowDelay > 0
};

function eachPreference(f) {
  for (var p in CONTROLSTATE) {
    if (CONTROLSTATE.hasOwnProperty(p)) {
      f(p, CONTROLSTATE);
    }
  }
}

function createKey(key) {
  return (widget.identifier || 'diskclock') + '-' + key;
}

function savePreferences() {
  if ('widget' in god) {
    eachPreference(function (p, o) {
      widget.setPreferenceForKey(o[p], createKey(p));
    });
  }
}

function cleansePreferences() {
  if ('widget' in god) {
    eachPreference(function (p, o) {
      widget.setPreferenceForKey(null, createKey(p));
    });
  }
}

function loadPreferences() {
  var value;
  if ('widget' in god) {
    D(widget.identifier);
    eachPreference(function (p, o) {
      value = widget.preferenceForKey(createKey(p));
      if (value != undefined) {
        o[p] = value;
      }
    });
  }
}


return app;

//end CGD.DisClock
};
